/****************************************************************/
/*   draw_graph.c	      					*/
/****************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "xad.h"

#define	WINDOW_HEIGHT	600
#define	WINDOW_WIDTH	600
#define FONT_NAME       "9x15"

extern Display	*theDisplay;
extern Window	theWindow;
extern GC	theGC;
extern int	theScreen;
extern int	theDepth;
int		Centries, Jentries;
XRectangle      *Cthe_recs;
XArc		*Jthe_arcs;
XFontStruct     *font_struct;
char            string[20], str[10];


#ifdef	NO_FORTRAN_HASH
dp_initialize(void)
#else NO_FORTRAN_HASH
dp_initialize_(void)
#endif NO_FORTRAN_HASH
{
	xad_open_window(100,100,WINDOW_HEIGHT,WINDOW_WIDTH,
                        XAD_WT_1_BW,"Draw_Graph");
	XClearWindow(theDisplay,theWindow);
	XFlush(theDisplay);
}

#ifdef	NO_FORTRAN_HASH
dp_draw_graph(float CY[], float JY[], int *Cent, int *Jent)
#else NO_FORTRAN_HASH
dp_draw_graph_(float CY[], float JY[], int *Cent, int *Jent)
#endif NO_FORTRAN_HASH
{
	int	i,j;
	float	y_point;

	free(Cthe_recs);
        free(Jthe_arcs);
	Centries=(*Cent);
	Jentries=(*Jent);
        Cthe_recs=(XRectangle *)malloc(sizeof(XRectangle)*Centries);
	Jthe_arcs=(XArc *)malloc(sizeof(XArc)*Jentries);

	XClearArea(theDisplay,theWindow,0,0,
                   WINDOW_HEIGHT,WINDOW_WIDTH,False);

        /* Drawing Axes */
        XDrawLine(theDisplay,theWindow,theGC,100,100,100,550);   /* y axis */
        XDrawLine(theDisplay,theWindow,theGC,40,400,500,400);    /* x axis */

        /* Drawing Text (label axes) */
        font_struct=XLoadQueryFont(theDisplay, FONT_NAME);
        XSetFont(theDisplay, theGC, font_struct->fid);

        (void) strcpy(string, "Error");
        XDrawImageString(theDisplay,theWindow,theGC,
                         70,90,string,strlen(string));

        (void) strcpy(string, "Iteration");
        XDrawImageString(theDisplay,theWindow,theGC,
                         450,430,string,strlen(string));

        XDrawRectangle(theDisplay,theWindow,theGC,280,163,6,6);
        (void) strcpy(string, "Conjugate Gradient");
        XDrawImageString(theDisplay,theWindow,theGC,
                         300,170,string,strlen(string));

        XFillArc(theDisplay,theWindow,theGC,280,193,7,7,0,23040);
        (void) strcpy(string, "Jacobi");
        XDrawImageString(theDisplay,theWindow,theGC,
                         300,200,string,strlen(string));


        /**** Drawing Graph ****/

        /* Conjugate Gradients */
        for(i=0;i<*Cent;++i)
        {	 
           y_point=CY[i];
	   Cthe_recs[i].x=i*10+110;
           Cthe_recs[i].y=397-y_point*150;
	   Cthe_recs[i].width=4;
	   Cthe_recs[i].height=4;
        }

        /* Jacobi */
        for(i=0;i<*Jent;++i)
        {	 
           y_point=JY[i];
	   Jthe_arcs[i].x=i*10+110;
           Jthe_arcs[i].y=397-y_point*150;
	   Jthe_arcs[i].width=5;
	   Jthe_arcs[i].height=5;
	   Jthe_arcs[i].angle1=0;
           Jthe_arcs[i].angle2=23040;                                
        }

        XDrawRectangles(theDisplay,theWindow,theGC,Cthe_recs,Centries);     
        XFillArcs(theDisplay,theWindow,theGC,Jthe_arcs,Jentries);  

	XFlush(theDisplay); 
     
}














